"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const prom_client_1 = require("prom-client");
exports.autometricRegister = new prom_client_1.Registry();
exports.metrics = {
    counter: new prom_client_1.Counter({
        help: `Autometric counter for the total amount of created counters`,
        name: "autometric_counters_total",
        registers: [exports.autometricRegister],
    }),
    registry: new prom_client_1.Counter({
        help: `Autometric counter for the total amount of created registers`,
        name: "autometric_registers_total",
        registers: [exports.autometricRegister],
    }),
    summary: new prom_client_1.Counter({
        help: `Autometric counter for the total amount of created summaries`,
        name: "autometric_summaries_total",
        registers: [exports.autometricRegister],
    }),
};
function createCounter(options) {
    exports.metrics.counter.inc();
    return new prom_client_1.Counter(options);
}
exports.createCounter = createCounter;
function createSummary(options) {
    exports.metrics.summary.inc();
    return new prom_client_1.Summary(options);
}
exports.createSummary = createSummary;
function createRegistry() {
    exports.metrics.registry.inc();
    return new prom_client_1.Registry();
}
exports.createRegistry = createRegistry;
