/// <reference types="node" />
/// <reference types="express" />
import { NextFunction } from "express";
import { IncomingMessage, ServerResponse } from "http";
import { Registry } from "prom-client";
import { IAutometricCallOptions, IAutometricCreateOptions } from "./common";
export interface ICreateAutometricMiddlewareOptions extends IAutometricCreateOptions {
    rewriteLabels?: (currentLabels: {
        [name: string]: string;
    }, createOptions: ICreateAutometricMiddlewareOptions, callOptions: {
        request: IncomingMessage;
        response: ServerResponse;
    }) => {
        [name: string]: string;
    };
    addMethodLabel?: boolean;
    addStatusCodeLabel?: boolean;
    addClosedByLabel?: boolean;
}
export interface IAutometricMiddlewareObject {
    readonly register: Registry;
    readonly prefix: string;
    readonly labels: {
        [name: string]: string;
    };
    readonly createMiddleware: (baseOptions?: IAutometricCallOptions) => (request: IncomingMessage, response: ServerResponse, next: NextFunction) => void;
}
export declare function createAutometricMiddleware(name: string, baseOptions?: ICreateAutometricMiddlewareOptions): IAutometricMiddlewareObject;
